package game.audio;

import game.init.SoundEvent;

public class SoundType
{
	public static final SoundType SLIME = new SoundType(SoundEvent.SLIME_BIG, SoundEvent.SLIME_SMALL, 1.0F, 1.0F);
//	{
//	    public Sounds getBreakSound()
//	    {
//	        return "mob.slime.big";
//	    }
//	    public Sounds getPlaceSound()
//	    {
//	        return "mob.slime.big";
//	    }
//	    public Sounds getStepSound()
//	    {
//	        return "mob.slime.small";
//	    }
//	};
	public static final SoundType ANVIL = new SoundType(SoundEvent.STONE, SoundEvent.ANVIL_LAND, SoundEvent.STONE, 0.3F, 1.0F);
//	{
//	    public Sounds getBreakSound()
//	    {
//	        return "dig.stone";
//	    }
//	    public Sounds getPlaceSound()
//	    {
//	        return "random.anvil_land";
//	    }
//	    public Sounds getStepSound() // fix ...
//	    {
//	        return "dig.stone";
//	    }
//	};
	public static final SoundType LADDER = new SoundType(SoundEvent.WOOD, null, 1.0F, 1.0F);
//	{
//	    public Sounds getBreakSound()
//	    {
//	        return "dig.wood";
//	    }
//	    public Sounds getStepSound()
//	    {
//	        return null;
//	    }
//	};
	public static final SoundType SNOW = new SoundType(SoundEvent.SNOW, 1.0F, 1.0F);
	public static final SoundType SAND = new SoundType(SoundEvent.SAND, 1.0F, 1.0F);
	public static final SoundType CLOTH = new SoundType(SoundEvent.CLOTH, 1.0F, 1.0F);
	public static final SoundType GLASS = new SoundType(SoundEvent.GLASS, SoundEvent.STONE, SoundEvent.STONE, 1.0F, 1.0F);
//	{
//	    public Sounds getBreakSound()
//	    {
//	        return "dig.glass";
//	    }
//	    public Sounds getPlaceSound()
//	    {
//	        return "dig.stone";
//	    }
//	};
	public static final SoundType METAL = new SoundType(SoundEvent.STONE, 1.0F, 1.5F);
	public static final SoundType PISTON = new SoundType(SoundEvent.STONE, 1.0F, 1.0F);
	public static final SoundType GRASS = new SoundType(SoundEvent.GRASS /* , null */ , 1.0F, 1.0F);
//	{
//	    public Sounds getStepSound()
//	    {
//	        return null;
//	    }
//	};
	public static final SoundType GRAVEL = new SoundType(SoundEvent.GRAVEL, 1.0F, 1.0F);
	public static final SoundType WOOD = new SoundType(SoundEvent.WOOD, 1.0F, 1.0F);
	public static final SoundType STONE = new SoundType(SoundEvent.STONE, 1.0F, 1.0F);

    private final SoundEvent breakSound;
    private final SoundEvent placeSound;
    private final SoundEvent stepSound;
    private final float volume;
//    private final float frequency;

    private SoundType(SoundEvent breakSound, SoundEvent placeSound, SoundEvent stepSound, float volume, float frequency)
    {
        this.breakSound = breakSound;
        this.placeSound = placeSound;
        this.stepSound = stepSound;
        this.volume = volume;
//        this.frequency = frequency;
    }

    private SoundType(SoundEvent breakPlaceSound, SoundEvent stepSound, float volume, float frequency)
    {
        this(breakPlaceSound, breakPlaceSound, stepSound, volume, frequency);
    }

    private SoundType(SoundEvent sound, float volume, float frequency)
    {
        this(sound, sound, sound, volume, frequency);
    }

    public SoundEvent getBreakSound()
    {
        return this.breakSound;
    }

    public SoundEvent getPlaceSound()
    {
        return this.placeSound;
    }

    public SoundEvent getStepSound()
    {
        return this.stepSound;
    }

    public float getVolume()
    {
        return this.volume;
    }

    public float getFrequency()
    {
        return 1.0f; // this.frequency;
    }
}