package game.command;

import game.dimension.Dimension;
import game.init.UniverseRegistry;

public class DimensionParser extends NonDefaultingParser {
	public DimensionParser(String name) {
		super(name);
	}

	public Object parse(ScriptEnvironment env, String input) {
		Dimension dim = UniverseRegistry.getDimension(input);
		if(dim != null)
			return dim;
		int id = Integer.MIN_VALUE;
		try {
			id = Integer.parseInt(input);
		}
		catch(NumberFormatException e) {
		}
		dim = UniverseRegistry.getDimension(id);
		if(dim == null)
			throw new ScriptException("Unbekannte Dimension '%s'", input);
		return dim;
	}
	
	public String[] getCompletions(ScriptEnvironment env) {
		return UniverseRegistry.getWorldNames().toArray(new String[UniverseRegistry.getWorldNames().size()]);
	}
}
