package game.gui;

import game.color.TextColor;
import game.gui.element.ActButton;
import game.gui.element.TransparentBox;
import game.init.Config;

public class GuiInfo extends Gui {
	private static final String INFO = 
	TextColor.GREEN + "" + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + " " + TextColor.VIOLET + "" + Config.VERSION + "" + 
	TextColor.GREEN + " " + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + "\n" + 
	"\n" + 
	TextColor.LGRAY + "Ein kleine Anwendung zur Simulation, zum Testen, für Spiele, Musik und vieles" + "\n" + 
	"mehr. Optimiert für Geschwindigkeit, Stabilität und" + TextColor.UNKNOWN + "" + TextColor.UNKNOWN + " [Speicherzugriffsfehler]" + "\n" + 
	"\n" + 
	TextColor.CYAN + "Geschrieben von Sen dem \"kleinen\" Dämonen " + TextColor.CRIMSON + TextColor.DEMON + TextColor.BLACK + TextColor.BLKHEART + "\n" + 
	"\n" + 
	TextColor.YELLOW + "Verwendete Programmbibliotheken:" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "axe_ork (Modifiziert: GLFW 3.3.8)" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "opl3 (Modifiziert: Nuked-OPL3 f2c9873)" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "nionet (Modifiziert: Netty 4.0.23-Final)" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "collectutil + futureutil (Modifiziert: Guava 17.0)" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "tjglu (Modifiziert: LWJGL 2.9.4-nightly-20150209)" + "\n" + 
//	"\n" + 
//	TextColor.YELLOW + "Verwendeter Compiler: " + "\n" + 
//	TextColor.LGRAY + "  -> " + TextColor.NEON + BUILD_COMP + "\n" + 
//	"\n" + 
//	TextColor.YELLOW + "Kompiliert auf System: " + "\n" + 
//	TextColor.LGRAY + "  -> " + TextColor.NEON + BUILD_SYS + "\n" + 
	"\n" + 
	"\n" + 
	TextColor.BLACK + "#0 " + TextColor.DGRAY + "#1 " + TextColor.GRAY + "#2 " + TextColor.LGRAY + "#3 " + TextColor.WHITE + "#4 " + TextColor.RED + "#5 " + TextColor.GREEN + "#6 " + 
	TextColor.BLUE + "#7 " + TextColor.YELLOW + "#8 " + TextColor.MAGENTA + "#9 " + TextColor.CYAN + "#A " + TextColor.VIOLET + "#B " + TextColor.ORANGE + "#C " + TextColor.CRIMSON + "#D " + 
	TextColor.MIDNIGHT + "#E " + TextColor.NEON + "#F " + TextColor.BROWN + "#G " + TextColor.DBROWN + "#H " + TextColor.DGREEN + "#I " + TextColor.DRED + "#J " + TextColor.DMAGENTA + "#K " + 
	TextColor.DVIOLET + "#L " + TextColor.ORK + "#M " + TextColor.ACID + "#N ";

	public static final GuiInfo INSTANCE = new GuiInfo("Über dieses Programm", INFO);

	private final String header;
	private final String info;
	
	public GuiInfo(String header, String info) {
		this.header = header;
		this.info = info;
	}
	
	public void init(int width, int height) {
		this.add(new TransparentBox(0, 0, width, height - 24, this.info));
		this.add(new ActButton(0, height - 24, width, 24, GuiMenu.INSTANCE, "Zurück"));
	}
	
	public String getTitle() {
		return this.header;
	}
}
