package game.renderer.entity;

import game.Game;
import game.block.BlockTNT;
import game.entity.item.EntityTnt;
import game.init.Blocks;
import game.renderer.BlockRenderer;
import game.renderer.GlState;
import game.renderer.texture.TextureMap;
import game.util.ExtMath;
import game.window.WCF;


public class RenderTntPrimed extends Render<EntityTnt>
{
    public RenderTntPrimed(RenderManager renderManagerIn)
    {
        super(renderManagerIn);
//        this.shadowSize = 0.5F;
    }

    /**
     * Renders the desired {@code T} type Entity.
     */
    public void doRender(EntityTnt entity, double x, double y, double z, float partialTicks)
    {
        BlockRenderer blockrendererdispatcher = Game.getGame().getBlockRendererDispatcher();
        WCF.glPushMatrix();
        WCF.glTranslatef((float)x, (float)y + 0.5F, (float)z);

        if ((float)entity.fuse - partialTicks + 1.0F < 10.0F)
        {
            float f = 1.0F - ((float)entity.fuse - partialTicks + 1.0F) / 10.0F;
            f = ExtMath.clampf(f, 0.0F, 1.0F);
            f = f * f;
            f = f * f;
            float f1 = 1.0F + f * 0.3F;
            WCF.glScalef(f1, f1, f1);
        }

        float f2 = (1.0F - ((float)entity.fuse - partialTicks + 1.0F) / 100.0F) * 0.8F;
        this.bindEntityTexture(entity);
        WCF.glTranslatef(-0.5F, -0.5F, 0.5F);
        blockrendererdispatcher.renderBlockBrightness(Blocks.tnt.getState().withProperty(BlockTNT.POWER, Integer.valueOf(entity.explosionSize)), entity.getBrightness(partialTicks));
        WCF.glTranslatef(0.0F, 0.0F, 1.0F);

        if (entity.fuse / 5 % 2 == 0)
        {
            GlState.disableTexture2D();
            GlState.disableLighting();
            GlState.enableBlend();
            GlState.blendFunc(770, 772);
            GlState.color(1.0F, 1.0F, 1.0F, f2);
            GlState.doPolygonOffset(-3.0F, -3.0F);
            GlState.enablePolygonOffset();
            blockrendererdispatcher.renderBlockBrightness(Blocks.tnt.getState().withProperty(BlockTNT.POWER, Integer.valueOf(entity.explosionSize)), 1.0F);
            GlState.doPolygonOffset(0.0F, 0.0F);
            GlState.disablePolygonOffset();
            GlState.color(1.0F, 1.0F, 1.0F, 1.0F);
            GlState.disableBlend();
            GlState.enableLighting();
            GlState.enableTexture2D();
        }

        WCF.glPopMatrix();
        super.doRender(entity, x, y, z, partialTicks);
    }

    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected String getEntityTexture(EntityTnt entity)
    {
        return TextureMap.locationBlocksTexture;
    }
}
