package game.renderer.layers;

import game.entity.npc.EntityNPC;
import game.renderer.GlState;
import game.renderer.entity.RenderHumanoid;
import game.renderer.model.ModelCharge;
import game.window.WCF;


public class LayerCharge implements LayerRenderer<EntityNPC>
{
    private static final String LIGHTNING_TEXTURE = "textures/entity/charge.png";
    
    private final RenderHumanoid main;
    private final ModelCharge charge = new ModelCharge(2.0F);

    public LayerCharge(RenderHumanoid main)
    {
        this.main = main;
    }

    public void doRenderLayer(EntityNPC entitylivingbaseIn, float p_177141_2_, float p_177141_3_, float partialTicks, float p_177141_5_, float p_177141_6_, float p_177141_7_, float scale)
    {
        if (entitylivingbaseIn.isCharged())
        {
//            boolean flag = entitylivingbaseIn.isInvisible();
            GlState.depthMask(true);
            this.main.bindTexture(LIGHTNING_TEXTURE);
            WCF.glMatrixMode(5890);
            WCF.glLoadIdentity();
            float f = (float)entitylivingbaseIn.ticksExisted + partialTicks;
            WCF.glTranslatef(f * 0.01F, f * 0.01F, 0.0F);
            WCF.glMatrixMode(5888);
            GlState.enableBlend();
            float f1 = 0.5F;
            GlState.color(f1, f1, f1, 1.0F);
            GlState.disableLighting();
            GlState.blendFunc(1, 1);
            this.charge.setModelAttributes(this.main.getMainModel());
            WCF.glScalef(entitylivingbaseIn.height, entitylivingbaseIn.height, entitylivingbaseIn.height);
            WCF.glTranslatef(0.0f, /* entitylivingbaseIn.isChild() ? 0.5f : */ -0.25f, 0.0f);
            this.charge.render(entitylivingbaseIn, p_177141_2_, p_177141_3_, p_177141_5_, p_177141_6_, p_177141_7_, scale);
            WCF.glMatrixMode(5890);
            WCF.glLoadIdentity();
            WCF.glMatrixMode(5888);
            GlState.enableLighting();
            GlState.disableBlend();
            GlState.depthMask(false);
        }
    }

    public boolean shouldCombineTextures()
    {
        return false;
    }
}
