package game.renderer.layers;

import game.Game;
import game.entity.animal.EntityMooshroom;
import game.init.Blocks;
import game.renderer.BlockRenderer;
import game.renderer.GlState;
import game.renderer.entity.RenderMooshroom;
import game.renderer.model.ModelQuadruped;
import game.renderer.texture.TextureMap;
import game.window.WCF;

public class LayerMooshroomMushroom implements LayerRenderer<EntityMooshroom>
{
    private final RenderMooshroom mooshroomRenderer;

    public LayerMooshroomMushroom(RenderMooshroom mooshroomRendererIn)
    {
        this.mooshroomRenderer = mooshroomRendererIn;
    }

    public void doRenderLayer(EntityMooshroom entitylivingbaseIn, float p_177141_2_, float p_177141_3_, float partialTicks, float p_177141_5_, float p_177141_6_, float p_177141_7_, float scale)
    {
        if (!entitylivingbaseIn.isChild()) // && !entitylivingbaseIn.isInvisible())
        {
            BlockRenderer blockrendererdispatcher = Game.getGame().getBlockRendererDispatcher();
            this.mooshroomRenderer.bindTexture(TextureMap.locationBlocksTexture);
            GlState.enableCull();
            GlState.cullFace(1028);
            WCF.glPushMatrix();
            WCF.glScalef(1.0F, -1.0F, 1.0F);
            WCF.glTranslatef(0.2F, 0.35F, 0.5F);
            WCF.glRotatef(42.0F, 0.0F, 1.0F, 0.0F);
            WCF.glPushMatrix();
            WCF.glTranslatef(-0.5F, -0.5F, 0.5F);
            blockrendererdispatcher.renderBlockBrightness(Blocks.red_mushroom.getState(), 1.0F);
            WCF.glPopMatrix();
            WCF.glPushMatrix();
            WCF.glTranslatef(0.1F, 0.0F, -0.6F);
            WCF.glRotatef(42.0F, 0.0F, 1.0F, 0.0F);
            WCF.glTranslatef(-0.5F, -0.5F, 0.5F);
            blockrendererdispatcher.renderBlockBrightness(Blocks.red_mushroom.getState(), 1.0F);
            WCF.glPopMatrix();
            WCF.glPopMatrix();
            WCF.glPushMatrix();
            ((ModelQuadruped)this.mooshroomRenderer.getMainModel()).head.postRender(0.0625F);
            WCF.glScalef(1.0F, -1.0F, 1.0F);
            WCF.glTranslatef(0.0F, 0.7F, -0.2F);
            WCF.glRotatef(12.0F, 0.0F, 1.0F, 0.0F);
            WCF.glTranslatef(-0.5F, -0.5F, 0.5F);
            blockrendererdispatcher.renderBlockBrightness(Blocks.red_mushroom.getState(), 1.0F);
            WCF.glPopMatrix();
            GlState.cullFace(1029);
            GlState.disableCull();
        }
    }

    public boolean shouldCombineTextures()
    {
        return true;
    }
}
