package game.renderer.texture;

import java.io.IOException;

import game.renderer.GlState;
import game.window.WCF;

public abstract class Texture
{
    protected int glTextureId = -1;

    public final int getGlTextureId()
    {
        if (this.glTextureId == -1)
        {
            this.glTextureId = WCF.glGenTextures();
        }

        return this.glTextureId;
    }

    public final void deleteGlTexture()
    {
        if (this.glTextureId != -1)
        {
            GlState.deleteTexture(this.glTextureId);
            this.glTextureId = -1;
        }
    }
    
    public abstract void loadTexture() throws IOException;
}
